#ifdef GL_ES
precision mediump float;
#endif

varying vec2 v_texcoord;
varying vec3 v_normal;

uniform vec3 u_AmbientLightSourceColor;
uniform vec4 u_color;

const int MAX_DIRECTIONAL_LIGHT_NUM = 1;
uniform vec3 u_DirLightSourceColor[MAX_DIRECTIONAL_LIGHT_NUM];
uniform vec3 u_DirLightSourceDirection[MAX_DIRECTIONAL_LIGHT_NUM];

void main()
{
    vec4 light_color = vec4(u_AmbientLightSourceColor, 1.0);
    vec3 normal = normalize(v_normal);

    for(int i = 0; i < MAX_DIRECTIONAL_LIGHT_NUM; ++i){
        float diffuse = dot(normal, -u_DirLightSourceDirection[i]);
        light_color.xyz += u_DirLightSourceColor[i] * max(0.0, diffuse);
    }
    
    gl_FragColor = texture2D(CC_Texture0,v_texcoord) * light_color * u_color;
}
