attribute vec3 a_position;
attribute vec2 a_texCoord;
attribute vec3 a_normal;

uniform float OutlineWidth;
uniform float OutlineDepthScale;
uniform float OutlineOffsetY;
uniform float OutlineOffsetZ;
uniform float Distance;

uniform vec4 WorldMatrix[3];

void main(void)
{
    a_texCoord;

    vec4 p = vec4(a_position, 1.0);
    vec4 position;
    position.x = dot(p, WorldMatrix[0]);
    position.y = dot(p, WorldMatrix[1]);
    position.z = dot(p, WorldMatrix[2]);
    position.w = p.w;
    
    vec4 n = vec4(a_normal, 0.0);
    vec3 normal;
    normal.x = dot(n, WorldMatrix[0]);
    normal.y = dot(n, WorldMatrix[1]);
    normal.z = dot(n, WorldMatrix[2]);

    position.xyz += normalize(normal) * (OutlineWidth + (Distance * 0.001 * OutlineDepthScale));
    position.y += OutlineOffsetY;
    position = CC_MVPMatrix * position;
    position.z += OutlineOffsetZ;
    gl_Position = position;
}
