attribute vec4 a_position;
attribute vec2 a_texCoord;
varying vec2 v_texcoord;

#ifdef BLEND_TEX2
attribute vec2 a_texCoord1;
varying vec2 v_texcoord1;
#endif

#ifdef BLEND_TEX3
attribute vec2 a_texCoord2;
varying vec2 v_texcoord2;
#endif

#ifdef WITH_NORMAL
attribute vec3 a_normal;
#endif

#ifdef WITH_VCOLOR
attribute vec4 a_color;
varying vec4 v_vColor;
#endif

uniform vec3 u_cameraPosition;
uniform float u_fogStart;
uniform float u_fogEnd;
uniform float u_fogPower;
varying float v_fogFactor;

void main()
{
    gl_Position = CC_MVPMatrix * a_position;
    
    vec4 position = CC_MVMatrix * a_position;
    position.xyz /= position.w;
    
#if FOG_MODE != 0
    v_fogFactor = pow( clamp( (length(position.xyz - u_cameraPosition) - u_fogStart) / (u_fogEnd - u_fogStart), 0.0, 1.0 ), u_fogPower );
#else
    u_cameraPosition, u_fogStart, u_fogEnd, u_fogPower, v_fogFactor;
#endif
    
  	v_texcoord.x = a_texCoord.x;
    v_texcoord.y = 1.0 - a_texCoord.y;
    
#ifdef BLEND_TEX2
    v_texcoord1.x = a_texCoord1.x;
    v_texcoord1.y = 1.0 - a_texCoord1.y;
#endif

#ifdef BLEND_TEX3
    v_texcoord2.x = a_texCoord2.x;
    v_texcoord2.y = 1.0 - a_texCoord2.y;
#endif
    
#ifdef WITH_NORMAL
    a_normal;
#endif
    
#ifdef WITH_VCOLOR
    v_vColor = a_color;
#endif
}
