#ifdef GL_ES
precision mediump float;
varying mediump vec2 v_texCoord;
uniform mediump vec4 threshold;
#else
varying vec2 v_texCoord;
uniform vec4 threshold;
#endif

uniform float blurSize;
uniform float intensity1;
uniform float intensity2;

void main()
{
    vec4 zero = vec4(0);
    
    float tempIntensity = intensity1;
    vec4 originalColor = texture2D(CC_Texture0, v_texCoord);
   
    float bright1 = originalColor.r + originalColor.g + originalColor.b;
    float bright2 = threshold.r + threshold.g + threshold.b;
    
    float a = step( bright2, bright1 );

    if( a == 1.0 ){
        tempIntensity = intensity1;
    }else{
        tempIntensity = intensity2;
    }
    
    vec4 base = max( zero, originalColor - threshold ) * 0.16;
    
    vec4 sum = base;
    float u = v_texCoord.x;
    float v = v_texCoord.y;
    
    // blur in x
    sum += max( zero, texture2D(CC_Texture0, vec2(u - 4.0*blurSize, v)) - threshold ) * 0.05;
    sum += max( zero, texture2D(CC_Texture0, vec2(u - 3.0*blurSize, v)) - threshold ) * 0.09;
    sum += max( zero, texture2D(CC_Texture0, vec2(u - 2.0*blurSize, v)) - threshold ) * 0.12;
    sum += max( zero, texture2D(CC_Texture0, vec2(u -     blurSize, v)) - threshold ) * 0.15;
    sum += base;
    sum += max( zero, texture2D(CC_Texture0, vec2(u +     blurSize, v)) - threshold ) * 0.15;
    sum += max( zero, texture2D(CC_Texture0, vec2(u + 2.0*blurSize, v)) - threshold ) * 0.12;
    sum += max( zero, texture2D(CC_Texture0, vec2(u + 3.0*blurSize, v)) - threshold ) * 0.09;
    sum += max( zero, texture2D(CC_Texture0, vec2(u + 4.0*blurSize, v)) - threshold ) * 0.05;
    
    // blur in y
    sum += max( zero, texture2D(CC_Texture0, vec2(u, v - 4.0*blurSize)) - threshold ) * 0.05;
    sum += max( zero, texture2D(CC_Texture0, vec2(u, v - 3.0*blurSize)) - threshold ) * 0.09;
    sum += max( zero, texture2D(CC_Texture0, vec2(u, v - 2.0*blurSize)) - threshold ) * 0.12;
    sum += max( zero, texture2D(CC_Texture0, vec2(u, v -     blurSize)) - threshold ) * 0.15;
    sum += base;
    sum += max( zero, texture2D(CC_Texture0, vec2(u, v +     blurSize)) - threshold ) * 0.15;
    sum += max( zero, texture2D(CC_Texture0, vec2(u, v + 2.0*blurSize)) - threshold ) * 0.12;
    sum += max( zero, texture2D(CC_Texture0, vec2(u, v + 3.0*blurSize)) - threshold ) * 0.09;
    sum += max( zero, texture2D(CC_Texture0, vec2(u, v + 4.0*blurSize)) - threshold ) * 0.05;
    
    gl_FragColor = vec4(sum.rgb*tempIntensity, sum.a);
}
