#ifdef GL_ES
precision mediump float;
varying mediump vec2 v_texCoord;
#else
varying vec2 v_texCoord;
#endif

uniform float intensity;

void main()
{
    float u = v_texCoord.x;
    float v = v_texCoord.y;
    float radius = 2.0;

#ifdef GL_ES
    mediump vec4 base = texture2D(CC_Texture0, vec2(u, v));
    mediump vec4 normal = base;
    mediump vec4 accum = vec4(0.0);
#else
    vec4 base = texture2D(CC_Texture0, vec2(u, v));
    vec4 normal = base;
    vec4 accum = vec4(0.0);
#endif
    
    float count = 0.0;
    for( float i = 1.0; i <= radius; i += 0.5 ){
        float rate = i * 0.01;
        accum += texture2D(CC_Texture0, vec2(u - rate, v - rate));
        accum += texture2D(CC_Texture0, vec2(u + rate, v - rate));
        accum += texture2D(CC_Texture0, vec2(u + rate, v + rate));
        accum += texture2D(CC_Texture0, vec2(u - rate, v + rate));
        count += 4.0;
    }
    accum *= 1.0 / count;
    
    float opacity = ((1.0 - normal.a) / radius) * 7.0;
    
    normal = (accum * opacity) + (normal * normal.a);
    normal.rgb = max( vec3(0.0), normal.rgb - base.rgb );
    normal.a = normal.a * 2.0;
    
    gl_FragColor = normal * (intensity*5.0);
}
