#ifdef GL_ES
precision lowp float;
#endif

uniform vec4 u_InnerColor1;
uniform vec4 u_InnerColor2;
uniform vec2 u_Pos1;
uniform vec2 u_Pos2;
uniform vec2 u_Pos3;

vec2 getIntersection(const in vec2 p1, const in vec2 p2,const in vec2 p3,const in vec2 p4)
{
    float d = (p2.x - p1.x)*(p4.y - p3.y) - (p2.y - p1.y)*(p4.x - p3.x);
    if (d == 0.0)
    {
        return vec2(1.0,0.0);
    }
    else
    {
        float u = ((p3.x - p1.x)*(p4.y - p3.y) - (p3.y - p1.y)*(p4.x - p3.x))/d;
        float v = ((p3.x - p1.x)*(p2.y - p1.y) - (p3.y - p1.y)*(p2.x - p1.x))/d;
        float x = p1.x + u * (p2.x - p1.x);
        float y = p1.y + u * (p2.y - p1.y);
        
        return vec2(x,y);
    }
}

void main()
{
    vec4 defaultColor = u_InnerColor1;
    vec4 changeColor = u_InnerColor2;
    vec2 intersection = getIntersection( gl_FragCoord.xy ,u_Pos1 ,u_Pos2 ,u_Pos3);
    float distance1 = distance( gl_FragCoord.xy,u_Pos1.xy);
    float distance2 = distance(intersection,u_Pos1.xy);
    float ratio = distance1 / distance2;
    float changeRatio = 0.5;
    
    if(ratio <= changeRatio)
    {
        gl_FragColor = defaultColor;
    }
    else
    {
        vec4 diff = (changeColor - defaultColor) / (1.0 - changeRatio);
        float plus = ratio - changeRatio;
        gl_FragColor = vec4(defaultColor.rgb + ( diff * plus ).rgb,defaultColor.a);
    }
}