#ifdef GL_ES
precision mediump float;
#endif

varying vec2 v_texcoord;
varying vec3 v_normal;

const int MAX_DIRECTIONAL_LIGHT_NUM = 1;
uniform vec3 u_DirLightSourceColor[MAX_DIRECTIONAL_LIGHT_NUM];
uniform vec3 u_DirLightSourceDirection[MAX_DIRECTIONAL_LIGHT_NUM];
uniform vec3 u_AmbientLightSourceColor;
uniform vec3 u_ToonColor[2];
uniform float u_Rate[2];
uniform float u_Threshold[1];
uniform vec4 u_color;

void main()
{
    vec3 normal = normalize(v_normal);
    float diffuse = dot(normal, -u_DirLightSourceDirection[0]);
    vec3 lightColor = u_AmbientLightSourceColor + u_DirLightSourceColor[0]*diffuse;
    
    vec4 base = texture2D(CC_Texture0, v_texcoord);
    if( diffuse > u_Threshold[0] ){
        base.xyz = base.xyz * mix(lightColor, u_ToonColor[0], u_Rate[0]);
    }else{
        base.xyz = base.xyz * mix(lightColor, u_ToonColor[1], u_Rate[1]);
    }
    
    gl_FragColor = base * u_color;
} 
