#ifdef GL_ES
precision mediump float;
#endif

varying vec2 v_texcoord;
varying vec3 v_normal;

const int MAX_DIRECTIONAL_LIGHT_NUM = 1;
uniform vec3 u_DirLightSourceColor[MAX_DIRECTIONAL_LIGHT_NUM];
uniform vec3 u_DirLightSourceDirection[MAX_DIRECTIONAL_LIGHT_NUM];
uniform vec3 u_AmbientLightSourceColor;
uniform vec4 u_color;

void main()
{
    u_AmbientLightSourceColor;
    u_DirLightSourceColor[0];

    vec3 u_ToonColor[2];
    u_ToonColor[0] = vec3(1.758953);
    u_ToonColor[1] = vec3(0.371806);

    float u_Rate[2];
    u_Rate[0] = 0.729723;
    u_Rate[1] = 0.0;

    float u_Threshold[1];
    u_Threshold[0] = 0.178751;

    vec3 ambientLightSourceColor = vec3(1.128840, 1.252657, 2.0);
    vec3 dirLightSourceColor = vec3(-2.0);

    vec3 normal = normalize(v_normal);
    float diffuse = dot(normal, -u_DirLightSourceDirection[0]);
    vec3 lightColor = ambientLightSourceColor + dirLightSourceColor[0]*diffuse;
    
    vec4 base = mix(texture2D(CC_Texture0, v_texcoord), vec4(1.0), 0.1);
    if( diffuse > u_Threshold[0] ){
        base.xyz = base.xyz * mix(lightColor, u_ToonColor[0], u_Rate[0]);
    }else{
        base.xyz = base.xyz * mix(lightColor, u_ToonColor[1], u_Rate[1]);
    }
    
    gl_FragColor = base * u_color;
} 
