#ifdef GL_ES
precision mediump float;
#endif

varying vec2 v_texcoord;
varying vec2 v_texcoord1;
varying vec2 v_texcoord2;

#ifdef GL_ES
uniform highp vec2 u_uvOffset;
#else
uniform vec2 u_uvOffset;
#endif

#ifdef WITH_VCOLOR
varying vec4 v_vColor;
#endif

uniform vec3 u_AmbientLightSourceColor;
uniform vec4 u_color;

const int MAX_DIRECTIONAL_LIGHT_NUM = 1;
uniform vec3 u_DirLightSourceColor[MAX_DIRECTIONAL_LIGHT_NUM];
uniform vec3 u_DirLightSourceDirection[MAX_DIRECTIONAL_LIGHT_NUM];

uniform vec3 u_fogColor;
varying float v_fogFactor;

void main()
{
    u_AmbientLightSourceColor;
    u_DirLightSourceColor[0];
    u_DirLightSourceDirection[0];
    
    vec2 uvOffsetB = u_uvOffset * 3.0;
    uvOffsetB.x *= -1.0;
    
    vec4 c0 = texture2D(CC_Texture0,v_texcoord + u_uvOffset);
    vec4 c1a = texture2D(CC_Texture1,v_texcoord1 + u_uvOffset);
    vec4 c1b = texture2D(CC_Texture1,v_texcoord1 + uvOffsetB);
    c0.rgb = c0.rgb + (c1a.rgb * c1b.rgb);
    
    vec4 c2 = texture2D(CC_Texture2,v_texcoord2);
    c0.rgb = c0.rgb * c2.rgb;
    
#ifdef WITH_VCOLOR
    c0 = c0 * u_color * v_vColor;
#else
    c0 = c0 * u_color;
#endif
    
#if FOG_MODE == 2
    gl_FragColor = vec4( c0.rgb + u_fogColor * v_fogFactor, c0.a );
#elif FOG_MODE == 1
    gl_FragColor = vec4( mix(c0.rgb, u_fogColor, v_fogFactor), c0.a );
#else
    u_fogColor, v_fogFactor;
    gl_FragColor = c0;
#endif
}
